﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LinearSolver
{


    public class Equation
    {
        public int Pivot;
        public int Value;
        private HashSet<int> AllVariables = new HashSet<int>();
        private HashSet<int> Rest = new HashSet<int>();
        public int CountVariables
        {
            get { return AllVariables.Count; }
        }
        public int First
        {
            get { return AllVariables.FirstOrDefault(); }
        }
        public HashSet<int> Variables
        {
            get { return AllVariables; }
        }

        public void UpdateEquation(int N, int NN)
        {
            foreach (int v in AllVariables.Reverse())
            {
                if (v + N > NN + 1) AllVariables.Remove(v);
                if (v + N == NN + 1)
                {
                    AllVariables.Remove(v);
                    Value = (Value + 1) % 2;
                }
            }
        }
        public void Prepare()
        {
            Rest.Clear();
            if (AllVariables.Count == 0) return;
            Pivot = AllVariables.First();
            int i = -1;
            foreach (int v in AllVariables)
            {
                i++;
                if (i == 0) continue;
                Rest.Add(v);
            }
        }

        public string GetLine()
        {
            string line = Value + "|";
            foreach (int v in AllVariables)
                line = line + " " + v;
            return line;
        }
        private int AddMod2(int a, int b)
        {
            return (a + b) % 2;
        }
        public void Add(int a)
        {
            if (AllVariables.Contains(a))
            {
                AllVariables.Remove(a);
            }
            else
            {
                AllVariables.Add(a);
            }
        }
        public void Propagate(Equation eq)
        {
            int pivot = eq.Pivot;
            if (AllVariables.Contains(pivot))
            {
                AllVariables.Remove(pivot);
                Value = AddMod2(Value, eq.Value);
                foreach (int v in eq.Rest)
                    Add(v);
            }

        }

    }
}
