﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SAT2MQ
{
    // inex 1=> n
    public class Matrix
    {
        private HashSet<string> _data = new HashSet<string>();
        private int ColNb;
        private int RowNb;

        public void Init(int rowNb, int colNb)
        {
            _data.Clear();
            ColNb = colNb;
            RowNb = rowNb;
        }
        public IList<int> GetColumn(int indexCol)
        {
            IList<int> col = new List<int>();
            for (int row = 1; row <= RowNb; row++)
            {
                if (row < indexCol) col.Add(0);
                if (row == indexCol) col.Add(1);
                if (row > indexCol)
                {
                    string key = row + "_" + indexCol;
                    if (_data.Contains(key))
                        col.Add(0);
                    else
                        col.Add(1);
                }
            }
            return col;
        }
        public int Getvalue(int row, int col)
        {
            if (col == 1) return 1;
            if (col + row > RowNb + 1) return 0;
            if (row + col == RowNb + 1) return 1;
            if (col > ColNb) return 1; // 1 if col > ColNb and col + row > RowNb+1
            string key = row + "_" + col;
            return _data.Contains(key) ? 0 : 1;
        }
        // Save only 0 values if row+ col < N
        public void UpdateCol(int indexCol, IDictionary<int, int> dic)
        {
            if (indexCol > ColNb) return;
            foreach (int idx in dic.Keys) // idx => variables
            {
                if (RowNb + 1 < idx + indexCol) continue;
                if (dic[idx] == 1) continue;
                string key = idx + "_" + indexCol;
                _data.Add(key);
            }
        }
    }

}
