﻿using LinearSolver;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TestLinearSolver
{
    class Program
    {
        static void Main(string[] args)
        {
             Console.ForegroundColor = ConsoleColor.DarkGreen;
            Console.WriteLine("Variables Number ?");
            int n = int.Parse(Console.ReadLine());

            Console.WriteLine("Clauses Number ?");
            int m = int.Parse(Console.ReadLine());
    
            Console.WriteLine("Start generating system " + DateTime.Now);
            LinearSystem ls = new LinearSystem();
            ls.ShowLog = true;

            ls.LoadLS();
            //ls.generateBinarySystem(n, m);

            Console.WriteLine("End generating system " +DateTime.Now);
            Stopwatch stopWatch = new Stopwatch();
            stopWatch.Start();
            IDictionary<int, int> dic =  ls.SolveP();
            stopWatch.Stop();
            // Get the elapsed time as a TimeSpan value.
            TimeSpan ts = stopWatch.Elapsed;
            string elapsedTime = String.Format("{0:00}:{1:00}:{2:00}.{3:00}",
            ts.Hours, ts.Minutes, ts.Seconds,
            ts.Milliseconds / 10);
            Console.WriteLine("RunTime " + elapsedTime);

            ls.CheckSolution(dic);
            if (dic.Count == 0)
                Console.WriteLine("Invalid System");
            ls.CountOnes(dic);
            Console.ReadKey();

        }
    }
}
